{{
 * @file Test_Time.spin
 * This is the main Test_Time program start point.
}} 

CON _clkmode = xtal1 + pll16x
    _clkfreq = 80_000_000
    vgaEnab  = 15
    vgaPins  = 16

OBJ dsp : "VGA_Text"

VAR long TBP, data_, MT_St, MT, MT1, MT1D, Stack[20]

PUB main | number, divisor
  cognew(Detect_Rate, @Stack)
  outa[vgaEnab]~
  dira[vgaEnab]~~
  dsp.start(vgaPins)
  dsp.str(string("Detect_Rate"))
  repeat   ' display MT1D in decimal as fast as possible
    dsp.str(string($0A,1,$0B,1))   ' position to row 1, column 1
    number := MT1D
    divisor := 100_000_000
    repeat 9   ' fixed width, non-zero suppressed decimal
      dsp.out((number / divisor) + "0")
      number //= divisor
      divisor /= 10
      
PUB Detect_Rate
  
  data_   := 18                     'sets product delivery rate
  TBP  := (3600*80_000) / data_     'TBP Time Between Product in clock tics
                                    ' 80_000_000 tics/sec
repeat

  if MT_St == 0                     
     MT := cnt                      'MT Mark Time, 1st time thru loop
     MT_St := 1
  if MT_St 
     MT1 := cnt - MT                'keep looking at MT1
     if MT1 => TBP                  
        MT_St := 0
        MT1D := MT1 - TBP           'This difference in Time seems to vary quite a bit
        waitcnt(2*clkfreq + cnt)    'I don't know why?
        data_++
        TBP := (3600*80_000) / data_
